10 REM *** (TRANALYS) FFT/INV FFT ***
11 REM MODIFIES SQUARE FUNCTION SPECTRUM & RECONSTRUCTS
12 SCREEN 9, 1: COLOR 15, 1
13 CLS : PRINT : PRINT "INPUT NUMBER OF DATA POINTS AS 2^N"
14 INPUT "N = "; N
16 Q = 2 ^ N
20 Q2 = Q / 2: Q3 = Q2 - 1: Q4 = Q / 4: Q5 = Q4 - 1: Q8 = Q / 8
21 FMN = 0: FMX = Q: FSTEP = 1
22 DIM Y(Q), C(2, Q), S(2, Q), KC(Q), KS(Q), F(2, (FTOP - FBOT) + 1)
23 DIM COMP(3, KB, KB), Z(2, KB, KB + 1)
24 X0 = 50: Y0 = 200: XSF = 500 / Q: YSF = 150: IOFLG = 1
30 PI = 3.141592653589793#: P2 = 2 * PI: K1 = P2 / Q: PI2 = P2
32 FOR I = 0 TO Q: KC(I) = COS(K1 * I): KS(I) = SIN(K1 * I): NEXT
40 CLS
50 PRINT SPC(30); "MAIN MENU": PRINT : PRINT
52 PRINT SPC(5); "1 = GENERATE STEP FUNCTION & TRANSFORM": PRINT
54 PRINT SPC(5); "2 = FORWARD TRANSFORM": PRINT
56 PRINT SPC(5); "3 = MODIFY SPECTRUM": PRINT
58 PRINT SPC(5); "4 = INVERSE TRANSFORM": PRINT
60 PRINT SPC(5); "5 = MODIFY SYSTEM": PRINT
62 PRINT SPC(5); "6 = EXIT": PRINT
70 PRINT SPC(10); "MAKE SELECTION :";
80 A$ = INKEY$: IF A$ = "" THEN 80
90 A = VAL(A$): ON A GOSUB 600, 100, 1000, 120, 140, 990
95 GOTO 40

100 REM *** FORWARD FFT ***
102 K6 = -1: SK1 = 2
104 CLS : HDR$ = "FREQ   F(COS)       F(SIN)       "
106 HDR$ = HDR$ + "FREQ   F(COS)       F(SIN)": PRINT : PRINT
108 GOSUB 180
RETURN

120 REM *** INVERSE TRANSFORM ***
122 SK1 = 1: K6 = 1
124 CLS : HDR$ = "TIME    AMPLITUDE   NOT USED     "
126 HDR$ = HDR$ + "TIME   AMPLITUDE     NOT USED": PRINT : PRINT
128 GOSUB 180
130 RETURN

140 CLS ' *** MODIFY SYSTEM PARAMETERS ***
142 PRINT "PRESENT DATA GRAPHICALLY? (Y/N):";
144 A$ = INKEY$: IF A$ = "" THEN 144
146 IF A$ = "Y" OR A$ = "y" THEN IOFLG = 1 ELSE IOFLG = -1
148 RETURN

180 REM *** FFT ROUTINE ***
181 T9 = TIMER
182 FOR M = 0 TO N - 1: QT = 2 ^ M: KT1 = 2 ^ (N - M - 1)
183 REM *** UNIVERSAL BUTTERFLY ***
184 FOR J = 0 TO Q3 STEP QT: J1 = 2 * J: K9 = J + Q2
185 FOR I = 0 TO QT - 1: KT = I * KT1: K = K9 + I
187 C(T0, J1 + I) = (C(T1, I + J) + C(T1, K) * KC(KT) - K6 * S(T1, K) * KS(KT)) / SK1
188 S(T0, J1 + I) = (S(T1, I + J) + K6 * C(T1, K) * KS(KT) + S(T1, K) * KC(KT)) / SK1
190 NEXT I
191 J1 = J1 + QT
192 FOR I = 0 TO QT - 1: KT = (I + QT) * KT1: K = K9 + I
194 C(T0, J1 + I) = (C(T1, I + J) + C(T1, K) * KC(KT) - K6 * S(T1, K) * KS(KT)) / SK1
195 S(T0, J1 + I) = (S(T1, I + J) + K6 * C(T1, K) * KS(KT) + S(T1, K) * KC(KT)) / SK1
196 NEXT I: NEXT J
197 IF T0 = 0 THEN T0 = 1: T1 = 0: GOTO 199
198 T0 = 0: T1 = 1
199 NEXT M

200 T9 = TIMER - T9
202 IF IOFLG = 1 THEN 250
206 ZSTP = 15
208 PRINT HDR$: PRINT : PRINT
210 FOR Z = 0 TO Q2 - 1
214 GOSUB 300
216 IF Z > ZSTP THEN 350 ' PRINT 1 SCREEN AT A TIME
220 NEXT Z
222 LOCATE 1, 1: PRINT : PRINT "TIME ="; T9
225 INPUT "C/R TO CONTINUE:"; A$
229 RETURN

250 REM *** PLOT OUTPUT ***
252 CLS : YPX = 0: IF K6 = -1 THEN 280
254 Y0 = 175
256 FOR I = 0 TO Q - 1 ' FIND MAX VALUE IN ARRAY
258 IF C(T1, I) > YPX THEN YPX = C(T1, I)' IF > YPX SWAP
260 NEXT I ' CHECK NEXT DATA POINT
262 YSF = 100 / YPX' SET Y SCALE FACTOR
263 LINE (X0 + 10, Y0 - 100)-(X0, Y0 - 100)
264 LOCATE 6, 1: PRINT USING "###.##"; YPX ' PRINT SCALE FACTOR
265 LINE (X0 - 1, 50)-(X0 - 1, 300)
266 LINE (X0, Y0)-(X0 + 500, Y0)
268 LINE (X0, Y0)-(X0, Y0) ' PEN TO ORIGIN
270 FOR I = 0 TO Q - 1
272 YP = C(T1, I)
274 IF K6 = -1 THEN YP = SQR(C(T1, I) ^ 2 + S(T1, I) ^ 2)
276 LINE -(X0 + XSF * I, Y0 - YSF * YP)
278 NEXT I
279 GOTO 222
280 ' *** FIND Y SCALE FACTOR FOR FREQ DOMAIN PLOT ***
281 Y0 = 300 ' SET Y AXIS ORIGIN
282 FOR I = 0 TO Q - 1' FIND LARGEST VALUE IN ARRAY
284 YP = SQR(C(T1, I) ^ 2 + S(T1, I) ^ 2): IF YP > YPX THEN YPX = YP
286 NEXT I ' CHECK NEXT DATA POINT
287 YSF = 200 / YPX' SET SCALE FACTOR
288 LINE (X0 + 10, Y0 - 200)-(X0, Y0 - 200)
289 LOCATE 8, 1: PRINT USING "###.##"; YPX: GOTO 265

300 PRINT USING "###"; Z; : PRINT "   ";
310 PRINT USING "+##.#####"; C(T1, Z); : PRINT "    ";
312 PRINT USING "+##.#####"; S(T1, Z); : PRINT "      ";
320 PRINT USING "###"; Z + Q2; : PRINT "   ";
322 PRINT USING "+##.#####"; C(T1, Z + Q2); : PRINT "    ";
324 PRINT USING "+##.#####"; S(T1, Z + Q2)
330 RETURN

350 REM ***  STOP WHEN SCREEN FULL  ***
352 ZSTP = ZSTP + 16
354 PRINT : INPUT "ENTER TO CONTINUE:"; A$
356 CLS : PRINT HDR$: PRINT : PRINT
358 GOTO 220

600 REM * SQUARE FUNCTION *
602 CLS : PRINT : PRINT
604 PRINT "PREPARING DATA INPUT - PLEASE WAIT!"
610 FOR I = 0 TO Q / 2 - 1
620 C(0, I) = -1: S(0, I) = 0
630 NEXT
640 FOR I = Q / 2 TO Q - 1
650 C(0, I) = 1: S(0, I) = 0
660 NEXT
670 T0 = 1: T1 = 0
680 GOSUB 100
690 RETURN

990 END

1000 REM ***************************************
1002 REM *           MODIFY SPECTRUM           *
1004 REM ***************************************
1040 CLS : RTFLG = 0
1042 IF K6 <> -1 THEN 1096
1050 PRINT SPC(30); "MODIFY SPECTRUM MENU": PRINT : PRINT
1060 PRINT SPC(5); "1 = TRUNCATE SPECTRUM": PRINT
1062 PRINT SPC(5); "2 = BUTTERWORTH RESPONSE": PRINT
1064 PRINT SPC(5); "3 = GAUSSIAN RESPONSE": PRINT
1066 PRINT SPC(5); "4 = CIRCUIT CONVOLUTION": PRINT
1067 PRINT SPC(5); "5 = INPUT CIRCUIT": PRINT
1068 PRINT SPC(5); "6 = EXIT": PRINT
1070 PRINT SPC(10); "MAKE SELECTION :";
1080 A$ = INKEY$: IF A$ = "" THEN 1080
1082 A = VAL(A$): ON A GOSUB 1100, 1200, 1300, 1400, 20000, 1990
1084 GOSUB 200
1088 IF RTFLG = 1 THEN RETURN
1090 GOTO 1040
1096 INPUT "MUST TRANSFORM SIGNAL BEFORE MODIFYING SPECTRUM"; A$
1098 RETURN

1100 REM * TRUNCATE SPECTRUM *
1102 CLS : PRINT : PRINT
1104 INPUT "ENTER DECIMAL FRACTION OF SPECTRUM TO REMOVE (I.E. 0.25)"; A$
1110 FC0 = VAL(A$): IF FC0 = 0 OR FC0 = 1 THEN 1104
1120 FCO = INT(Q2 * FC0 + .5)
1130 FOR I = Q2 - FCO TO Q2 + FCO
1140 C(T1, I) = 0: S(T1, I) = 0
1150 NEXT I
1194 RTFLG = 1: RETURN

1200 REM * BUTTERWORTH RESPONSE *
1202 CLS : PRINT : PRINT
1204 PRINT "ENTER THE 3db CUTOFF HARMONIC NUMBER (1 TO "; Q3; ")";
1206 INPUT A$
1208 FC0 = VAL(A$): IF FC0 = 0 OR FC0 > Q3 THEN 1204
1210 NP = 5: REM NUMBER OF POLES = NP
1220 FOR I = 1 TO Q3
1222 ATTN = 1 / SQR(1 + (I / FC0) ^ (2 * NP))
1224 C(T1, I) = ATTN * C(T1, I): S(T1, I) = ATTN * S(T1, I)
1226 C(T1, Q - I) = ATTN * C(T1, Q - I): S(T1, Q - I) = ATTN * S(T1, Q - I)
1228 NEXT I
1230 ATTN = 1 / SQR(1 + (Q2 / FC0) ^ (2 * NP))
1234 C(T1, Q2) = ATTN * C(T1, Q2)
1294 RTFLG = 1: RETURN

1300 REM * GAUSSIAN RESPONSE *
1302 CLS : PRINT : PRINT
1304 PRINT "ENTER THE 3db CUTOFF HARMONIC NUMBER (1 TO "; Q3; ")";
1306 INPUT A$
1308 FC0 = VAL(A$): IF FC0 = 0 OR FC0 > Q3 THEN 1304
1320 FOR I = 1 TO Q3
1322 ATTN = 1 / SQR(EXP(.3 * ((I / FC0) ^ 2)))
1324 C(T1, I) = ATTN * C(T1, I): S(T1, I) = ATTN * S(T1, I)
1326 C(T1, Q - I) = ATTN * C(T1, Q - I): S(T1, Q - I) = ATTN * S(T1, Q - I)
1328 NEXT I
1330 ATTN = 1 / SQR(EXP(.3 * ((Q2 / FC0) ^ 2)))
1334 C(T1, Q2) = ATTN * C(T1, Q2): S(T1, Q2) = ATTN * S(T1, Q2)
1394 RTFLG = 1: RETURN

1400 REM *  CONVOLVE WITH CIRCUIT XFER FUNCTION  *
1402 CLS : PRINT : PRINT
1404 PRINT SPC(10); "CONVOLVING XFER FUNCTION WITH STEP FUNCTION"
1410 FOR I3 = 0 TO Q3
1412 GOSUB 10000 ' COMPUTE XFER FUNCTION
1420 CAT = ATTNR * C(T1, I3) - ATTNI * S(T1, I3)' COMPLEX CONVOLUTION
1422 SAT = ATTNI * C(T1, I3) + ATTNR * S(T1, I3)' IMAG TERM
1424 C(T1, I3) = CAT: S(T1, I3) = SAT' POS FREQS
1426 C(T1, Q - I3) = CAT: S(T1, Q - I3) = -SAT' NEG FREQS
1428 NEXT I3 ' GET NEXT FREQUENCY DATA POINT
1430 I3 = Q2: GOSUB 10000 ' DO NYQUEST FREQUENCY
1432 C(T1, I3) = ATTNR * C(T1, I3): S(T1, I3) = 0
1490 RTFLG = 1: RETURN

1990 REM * EXIT MODIFY SPECTRUM ROUTINE *
1992 RTFLG = 1: RETURN

10000 F = I3: FREQ = I3
10010 GOSUB 11000 ' CALC IMPEDANCE MATRIX
10020 GOSUB 12000 ' SOLVE FOR CURRENTS
10030 ATTNR = RTERM * Z(1, KB, KB + 1): ATTNI = RTERM * Z(2, KB, KB + 1)
10090 RETURN

REM ***********************************
REM *       COMPUTE IMPEDANCE         *
REM ***********************************
11000 CLS : WF = PI2 * F ' GET ANGULAR FREQUENCY
11010 FOR I = 1 TO KB ' FOR ALL MESHES
11020 Z(1, I, I) = COMP(1, I, I) ' GET RESISTANCE VALUE
11030 IF COMP(3, I, I) = 0 THEN Z(2, I, I) = WF * COMP(2, I, I): GOTO 11060
11040 IF F = 0 THEN Z(2, I, I) = -1E+26: GOTO 11060 ' FUDGE DC CAP
11050 Z(2, I, I) = WF * COMP(2, I, I) - 1 / (WF * COMP(3, I, I)) ' REACTANCE
11060 FOR J = I + 1 TO KB ' GET ALL MUTUAL IMPEDANCES
11070 Z(1, I, J) = -COMP(1, I, J) ' MUTUAL RESISTANCE
11080 IF COMP(3, I, J) = 0 THEN Z(2, I, J) = -WF * COMP(2, I, J): GOTO 11110
11090 IF F = 0 THEN Z(2, I, I) = -1E+26: GOTO 11110 ' FUDGE DC CAP
11100 Z(2, I, J) = -(WF * COMP(2, I, J) - 1 / (WF * COMP(3, I, J)))
11110 Z(2, J, I) = Z(2, I, J): Z(1, J, I) = Z(1, I, J) ' MAKE SYMMETRICAL
11120 NEXT J ' GET NEXT MUTUAL IMPEDANCE
11130 NEXT I ' GET NEXT MESH
11140 Z(1, 1, KB + 1) = 1: Z(2, 1, KB + 1) = 0 ' DRIVE POINT VOLTAGE
11150 FOR I = 2 TO KB ' GET ALL OTHER MESH VOLTAGE SOURCES
11160 Z(1, I, KB + 1) = 0: Z(2, I, KB + 1) = 0 ' SET TO ZERO
11170 NEXT I
11250 RETURN

REM ***********************************
REM *        SOLVE FOR CURRENTS       *
REM ***********************************
12000 FOR J = 1 TO KB ' STEP THROUGH ALL DIAGONAL LOCATIONS
12200 REM GET A "1" COEFFICIENT ON THE DIAGONAL
12210 IF Z(2, J, J) = 0 THEN ZRE = 1 / Z(1, J, J): ZIM = 0: GOTO 12300
12220 IF Z(1, J, J) = 0 THEN ZRE = 0: ZIM = -1 / Z(2, J, J): GOTO 12300
12230 BTA = ATN(Z(2, J, J) / Z(1, J, J)): IF Z(1, J, J) < 0 THEN BTA = BTA + PI
12240 BTA = .5 * SIN(2 * BTA)
12250 ZRE = BTA / Z(2, J, J): ZIM = -BTA / Z(1, J, J) ' INVERT Z(x,J,J)
12300 FOR K = J TO KB + 1
12310 Z1 = Z(1, J, K) * ZRE - (Z(2, J, K) * ZIM): Z(2, J, K) = Z(1, J, K) * ZIM + (Z(2, J, K) * ZRE): Z(1, J, K) = Z1
12320 NEXT K
12330 FOR I = 1 TO KB ' GET 0 IN THIS "CURRENT" POSITION (COL) FOR ALL OTHER EQNS.
12340 IF I = J THEN 12400
12350 XT = Z(1, I, J): YT = Z(2, I, J): IF XT = 0 AND YT = 0 THEN 12400
12360 FOR K = J + 1 TO KB + 1' DON'T BOTHER WITH "ZERO" POSITIONS
12370 Z(1, I, K) = Z(1, I, K) - (Z(1, J, K) * XT - (Z(2, J, K) * YT))
12380 Z(2, I, K) = Z(2, I, K) - (Z(1, J, K) * YT + (Z(2, J, K) * XT))
12390 NEXT K
12400 NEXT I
12410 NEXT J ' REPEATE FOR ALL DIAGONAL POSITIONS.
12420 RETURN

REM ***********************************
REM *       PRINTOUT CURRENTS         *
REM ***********************************
13000 CLS : PRINT
13010 FOR I = 1 TO KB
13020 PRINT "I"; I; "=";
13030 PRINT USING "###.###"; Z(1, I, KB + 1);
13040 PRINT "+j";
13050 PRINT USING "###.###"; Z(2, I, KB + 1)
13060 NEXT I
13070 REM INPUT "C/R TO CONTINUE"; A$
13080 RETURN

REM ***********************************
REM *     INPUT CIRCUIT ELEMENTS      *
REM ***********************************
20000 PRINT : PRINT "          INPUT CIRCUIT ELEMENTS"
20010 PRINT : INPUT "ENTER NUMBER OF MESHES"; KB
20020 REDIM COMP(3, KB, KB), Z(2, KB, KB + 1)
20030 GOSUB 21000
20040 FOR I = 1 TO KB
20050 PRINT : PRINT "INPUT VALUES FOR MESH "; I
20060 PRINT
20070 PRINT "ENTER MESH SELF RESISTANCE, INDUCTANCE, CAPACITANCE";
20080 INPUT COMP(1, I, I), COMP(2, I, I), COMP(3, I, I)
20090 FOR J = I + 1 TO KB
20100 REM PRINT
20110 PRINT "ENTER MESH ";
20120 PRINT USING "##_ "; I; J;
20130 PRINT " MUTUAL RESISTANCE, INDUCANCE, CAPACITANCE";
20140 INPUT COMP(1, I, J), COMP(2, I, J), COMP(3, I, J)
20150 COMP(1, J, I) = COMP(1, I, J): COMP(2, J, I) = COMP(2, I, J): COMP(3, J, I) = COMP(3, I, J)
20160 NEXT J
20170 NEXT I
20180 INPUT "ENTER TERMINATION RESISTANCE"; RTERM
20260 RETURN

REM ***************************************
REM *            INSTRUCTIONS             *
REM ***************************************
21000 PRINT "1) LAYOUT CIRCUIT INTO MESHES"
21010 PRINT "2) MESH SELF IMPEDANCE = SERIES SUMMATION OF ALL IMPEDANCES IN LOOP"
21020 PRINT "3) MESH MUTUAL IMPEDANCE = COMMON IMPEDANCES BETWEEN LOOPS"
21040 RETURN

